;March 2014 disassembly of Herb Johnson's 4/40
;ROM set in his Intel MDS 4/40 system
;assembled with A04 Nov 2014 HRJ
;updated Mar 2014 bad byte at 25EH, 035H
;updated Dec 2014 bad byte at 0CFH
;update Aug 2020 "evens" pseudoop

;there will be "B" branching errors flagged past
;address 0100H because the disassembler did not create word values
;but the assembler creates the correct byte-address values. - Herb

 ORG 0000H
 RPAIRS "EVENS"

;registers
R0 equ 0
R1 equ 1
R2 equ 2
R3 equ 3
R4 equ 4
R5 equ 5
R6 equ 6
R7 equ 7
R8 equ 8
R9 equ 9
R10 equ 10
R11 equ 11
R12 equ 12
R13 equ 13
R14 equ 14
R15 equ 15

;register pairs
P0 equ 0
P1 equ 2
P2 equ 4
P3 equ 6
P4 equ 8
P5 equ 10
P6 equ 12
P7 equ 14

;codes for conditional jumps
AN equ 0CH ;nonzero
AZ equ 04H ;zero
CN equ 0AH ;nocarry
CZ equ 02H ;carry
TN equ 01H ;nontest
TZ equ 09H ;test

;issue with branches - they are byte addresses not word addresses
;standard is to use text lables, not relative addresses
;but A04 will produce proper address but flag as error

 LDM 4
 XCH R0
 SRC P0
 LDM 8
 WRR
 JUN 354
 JMS 86
 FIM P1,46
 JMS 129
 JMS 156
 FIM P6, 208
 FIM P0,66
 FIM P2, 42
 FIM P3, 234
 JMS 412
 JCN AN, 28
 JIN P2
 ISZ R1, 31
 INC R0
 INC R5
 ISZ R5, 35
 INC R4
 ISZ R7, 23
 ISZ R6, 23
 JUN 250
 NOP
 JUN 646
 JUN 250
 JUN 512
 JUN 768
 JUN 250
 JUN 250
 JUN 250
 JUN 999
 JUN 347
 JUN 352
 JUN 885
 JUN 938
 JUN 699
 JUN 250
 JUN 543
 JUN 250
 JUN 705
 JUN 786
 JUN 968
 JUN 250
 JUN 250
 JUN 424
 FIM P1, 13
 JMS 129
 FIM P1, 10
 JUN 129
 JMS 1015
 RD0
 XCH R10
 RD1
 XCH R11
 RD2
 XCH R12
 CLC
 ISZ R12, 110
 ISZ R11, 110
 ISZ R10, 110
 BBL 0
 LD R10
 WR0
 LD R11
 WR1
 LD R12
 WR2
 INC R0
 SRC P0
 RD2
 SUB R12
 CMC
 RD1
 SUB R11
 CMC
 RD0
 SUB R10
 BBL 0
 FIM P1, 32
 JMS 1015
 WMP
 LDM 8
 XCH R4
 JMS 857
 CLC
 XCH R2
 RAR
 XCH R2
 XCH R3
 RAR
 XCH R3
 TCC
 WMP
 ISZ R4, 134
 JMS 857
 LDM 1
 WMP
 JMS 857
 JMS 857
 BBL 0
 CLB
 FIM P3, 64
 SRC P3
 WMP
 LDM 8
 XCH R4
 JMS 1015
 RDR
 RAR
 JCN CN, 165
 JMS 863
 SRC P3
 WMP
 SRC P0
 WMP
 JMS 857
 RDR
 CMA
 WMP
 RAR
 LD R2
 RAR
 XCH R2
 LD R3
 RAR
 XCH R3
 ISZ R4, 175
 JMS 857
 LDM 1
 WMP
 JMS 857
 JMS 863
 XCH R2
 RAL
 CLC
 RAR
 XCH R2
 BBL 0
 FIM P1, 48
 CLC
 DAA
 LD  1
 LDM 3
 INC R2
 IAC
 XCH R3
 JUN 129
 FIM P6, 196
 FIM P1, 0
 JMS 129
 ISZ R13, 218
 ISZ R12, 218
 BBL 0
 CLB
 LDM 3
 SUB R2
 JCN AN, 237
 CLC
 LD R3
 DAA
 JCN CZ, 248
 XCH R2
 BBL 0
 IAC
 JCN AN, 248
 CLC
 LDM 9
 XCH R3
 JCN AZ, 248
 ADD R3
 JCN CN, 235
 STC
 BBL 0
 FIM P1, 42
 JMS 129
 JUN 7
 JMS 1015
 RD3
 NOP
 NOP
 LDM 1
 JUN 157
 FIM P0, 60
 ISZ R1, 10
 ISZ R0, 10
 FIM P0, 60
 ISZ R1, 16
 ISZ R0, 16
 BBL 0
 NOP
 NOP
 NOP
 NOP
 NOP
 NOP
 NOP
 NOP
 NOP
 NOP
 NOP
 NOP
 NOP
 NOP
 NOP
 NOP
 NOP
 NOP
 NOP
 NOP
 NOP
 INC R12
 INC R12
 FIM P5, 0
 FIM P7, 0
 LDM 0
 XCH R13
 JMS 156
 JMS 225
 JCN CZ, 62
 LD R2
 XCH R15
 XCH R14
 XCH R13
 JUN 306
 SRC P5
 LD R13
 WR0
 LD R14
 WR1
 LD R15
 WR2
 INC R10
 FIM P0, 44
 JMS 412
 JCN AZ, 87
 FIM P0, 13
 JMS 412
 JCN AN, 89
 JMS 90
 ISZ R12, 89
 BBL 0
 ISZ R12, 46
 JUN 250
 JMS 298
 LDM 1
 JUN 355
 JMS 298
 LDM 0
 FIM P0, 0
 SRC P0
 WR3
 JUN 7
 FIM P0, 224
 SRC P0
 LDM 1
 WRR
 JMS 398
 LD R2
 WPM
 LD R3
 WPM
 JMS 94
 BBL 0
 FIM P0, 224
 SRC P0
 CLB
 WRR
 JMS 398
 WPM
 WPM
 FIM P0, 224
 SRC P0
 RDR
 XCH R2
 INC R0
 SRC P0
 RDR
 XCH R3
 XCH R11
 XCH R12
 XCH R10
 XCH R11
 BBL 0
 JMS 1015
 RD1
 XCH R10
 RD2
 XCH R11
 RD0
 FIM P0, 240
 SRC P0
 WRR
 XCH R12
 SRC P5
 BBL 0
 CLC
 LD R0
 SUB R2
 JCN AN, 167
 CLC
 LD R1
 SUB R3
 JCN AN, 167
 BBL 0
 BBL 1
 JMS 299
 JMS 86
 FIM P1, 58
 JMS 129
 FIM P4, 0
 JMS 375
 FIM P1, 16
 FIM P3, 16
 CLC
 LD R15
 SUB R12
 XCH R12
 ISZ R11, 194
 ISZ R10, 194
 JUN 458
 CMC
 LD R14
 SUB R11
 CMC
 LD R13
 SUB R10
 JCN CZ, 212
 CLB
 XCH R2
 LD R12
 XCH R3
 ISZ R3, 209
 INC R2
 LD R12
 CMA
 XCH R7
 JMS 870
 JMS 375
 CLB
 XCH R2
 XCH R10
 XCH R3
 JMS 870
 XCH R11
 XCH R2
 XCH R12
 XCH R3
 JMS 870
 FIM P1, 0
 JMS 870
 JMS 375
 JMS 870
 JMS 94
 TCC
 XCH R6
 ISZ R7, 232
 CLB
 SUB R9
 XCH R3
 CMC
 LDM 0
 SUB R8
 XCH R2
 JMS 870
 LD R6
 JCN AN, 170
 JUN 7

 JMS 299
 SRC P0
 RD0
 JMS 203
 RD1
 JMS 203
 RD2
 JMS 203
 JMS 127
 JMS 375
 JMS 870
 JMS 94
 JCN CN, 29
 LD R12
 JCN AN, 12
 JMS 86
 JUN 514
 JUN 7
 JMS 300
 LDM 13
 XCH R13
 LDM 0
 XCH R4
 SRC P2
 LD R15
 WRR
 INC R4
 SRC P2
 LD R14
 WRR
 JMS 375
 INC R4
 SRC P2
 LD R3
 CMA
 WRR
 INC R4
 SRC P2
 LD R2
 CMA
 WRR
 FIM P3, 64
 SRC P3
 LDM 2
 WMP
 FIM P4, 199
 JMS 264
 ISZ R9, 63
 ISZ R8, 63
 CLB
 WMP
 JMS 264
 LDM 2
 XCH R4
 SRC P2
 RDR
 CMA
 XCH R1
 INC R4
 SRC P2
 RDR
 CMA
 XCH R0
 JMS 412
 JCN AZ, 100
 ISZ R13, 35
 JMS 127
 LD R14
 XCH R2
 LD R15
 XCH R3
 JMS 870
 JUN 250
 ISZ R15, 106
 ISZ R14, 106
 JUN 7
 JMS 94
 JCN CZ, 33
 JUN 7
 JMS 256
 JMS 225
 XCH R2
 XCH R15
 JMS 256
 JMS 225
 XCH R2
 XCH R3
 XCH R15
 XCH R2
 CLC
 LD R9
 ADD R3
 XCH R9
 LD R8
 ADD R2
 XCH R8
 BBL 0
 JMS 299
 JMS 214
 LDM 12
 XCH R6
 JMS 375
 XCH R2
 XCH R10
 XCH R3
 XCH R11
 LDM 8
 XCH R9
 FIM P1, 66
 JMS 129
 CLC
 XCH R11
 RAL
 XCH R11
 XCH R10
 RAL
 XCH R10
 JCN CZ, 165
 FIM P1, 80
 JUN 679
 FIM P1, 78
 JMS 129
 ISZ R9, 152
 FIM P1, 70
 JMS 129
 JMS 127
 JMS 94
 JCN CN, 189
 ISZ R6, 140
 JMS 86
 JUN 650
 JMS 298
 JMS 214
 JUN 7
 JMS 298
 JMS 256
 FIM P0, 58
 JMS 412
 JCN AN, 195
 FIM P4, 0
 JMS 624
 LD R3
 JCN AN, 213
 LD R2
 JCN AZ, 254
 CLB
 SUB R3
 XCH R14
 CMC
 LDM 0
 SUB R2
 XCH R13
 JMS 624
 JMS 1015
 LD R3
 WR0
 JMS 624
 JMS 1015
 LD R2
 WR1
 XCH R3
 WR2
 JMS 624
 JMS 624
 JMS 361
 ISZ R14, 236
 ISZ R13, 236
 JMS 624
 LD R8
 JCN AN, 252
 LD R9
 JCN AZ, 195
 JUN 250
 JUN 7
 JMS 298
 FIM P1, 58
 JMS 129
 FIM P1, 48
 JMS 129
 FIM P1, 48
 JMS 129
 JMS 86
 JUN 701
 JMS 298
 JMS 375
 LD R3
 XCH R9
 LD R2
 JMS 203
 LD R9
 JMS 203
 FIM P1, 45
 JMS 129
 FIM P7, 0
 FIM P6, 0
 JMS 156
 JMS 225
 JCN CZ, 51
 FIM P6, 15
 LD R2
 XCH R15
 XCH R14
 JUN 806
 FIM P0, 32
 JMS 412
 JCN AN, 71
 ISZ R13, 67
 LD R15
 XCH R3
 LD R14
 XCH R2
 JMS 361
 JUN 788
 JMS 94
 JUN 788
 FIM P0, 13
 JMS 412
 JCN AZ, 79
 JUN 250
 ISZ R13, 87
 LD R15
 XCH R3
 LD R14
 XCH R2
 JMS 361
 JUN 7
 FIM P0, 243
 ISZ R1, 91
 ISZ R0, 91
 FIM P0, 243
 ISZ R1, 97
 ISZ R0, 97
 BBL 0
 CLC
 LD R3
 ADD R9
 XCH R9
 LD R2
 ADD R8
 XCH R8
 XCH R3
 XCH R5
 LD R2
 JMS 203
 LD R5
 JUN 203
 JMS 299
 JMS 256
 FIM P0, 66
 JMS 412
 JCN AN, 119
 LDM 8
 XCH R9
 FIM P5, 0
 JMS 256
 FIM P0, 80
 JMS 412
 JCN AN, 156
 CLC
 XCH R11
 RAL
 XCH R11
 XCH R10
 RAL
 XCH R10
 ISZ R9, 131
 JMS 256
 XCH R10
 XCH R2
 XCH R11
 XCH R3
 JUN 932
 FIM P0, 78
 JMS 412
 JCN AZ, 140
 JUN 250
 JMS 361
 JCN CZ, 119
 JUN 7
 JMS 300
 JMS 375
 FIM P0, 224
 SRC P0
 LDM 1
 WRR
 FIM P0, 240
 SRC P0
 LD R13
 WRR
 SRC P7
 LD R2
 WPM
 LD R3
 WPM
 ISZ R15, 194
 ISZ R14, 194
 INC R13
 JMS 94
 JCN CZ, 172
 JUN 7
 JMS 298
 FIM P4, 0
 LDM 0
 XCH R4
 SRC P2
 LD R9
 WRR
 INC R4
 SRC P2
 LD R8
 WRR
 INC R4
 SRC P2
 RDR
 CMA
 XCH R3
 INC R4
 SRC P2
 RDR
 CMA
 XCH R2
 JMS 361
 ISZ R9, 204
 ISZ R8, 204
 JUN 7
 JMS 299
 JMS 375
 LD R2
 CMA
 XCH R2
 LD R3
 CMA
 XCH R3
 JMS 361
 JCN CZ, 233
 JUN 7
 FIM P0, 0
 SRC P0
 BBL 0
 NOP
 NOP
 NOP
 NOP

 END

